﻿// ==UserScript==
// @name        Poissotron
// @namespace   MH
// @description Client Poissotron
// @include     */mountyhall/MH_Play/Play_a_ActionResult*
// @include     */mountyhall/MH_Play/Options/Play_o_Interface*
// @exclude     *trolls.ratibus.net*
// @exclude     *it.mh.raistlin.fr*
// @exclude     *mh2.mh.raistlin.fr*
// @exclude     *mhp.mh.raistlin.fr*
// @exclude     *mzdev.mh.raistlin.fr*
// @version     0.42
// @downloadURL https://mz.mh.raistlin.fr/poissotron/js/poissotron.user.js
// ==/UserScript==

// vérif UTF-8 ş

var oPOISSOTRON;
if (!oPOISSOTRON) {
	oPOISSOTRON = {
		url: 'https://mz.mh.raistlin.fr/poissotron/s.php',
		urldev: 'https://mz.mh.raistlin.fr/poissotrondev/s.php',
		erreur: undefined,	// dernière erreur
		debug: false,	// à positionner "en dur"
		// les suivants sont initialisés dans init()
		dev: false,
		idTroll: 0,
		modeTest: 0,

		sendDices: function() {	// Point d'entrée des pages de retour de sort/compétence. Récupère le résultat du jet et l'envoie au serveur.

			// Roule 13/12/2019 Pour l'instant, je mime le fonctionnement d'autrefois
			// Roule 31/12/2019 Ça diverge de plus en plus de la version Tilk :)
			var oData = {};
			var jets = [];

			// Roule 13/12/2019 ça sert à quoi ???
			var node = document.evaluate("//td/text()[contains(., 'Page générée en')]",
								document, null, 2, null).stringValue;
			if (node) {
				oData.temps = node.substring(node.indexOf('générée')+11, node.indexOf('sec')-1);
			}

			// date heure de l'événement
			var node = document.getElementById('hserveur');
			if (node) {
				var tstring = node.textContent.replace(']', '');
				// Date.parse() fonctionne bien mais attend un format MM/dd/yyyy. On intervertit mois/jour
				var tstring2 = tstring.substring(3, 5) + tstring.substring(2, 3) + tstring.substring(0, 2) + tstring.substring(5);
				var tstamp = Date.parse(tstring2);
				if (this.debug) window.console.log('[POIS] datetime, chaine1=' + tstring + ', chaine2=' + tstring2 + ', parse=' + tstamp);
				if (isNaN(tstamp)) {
					oData.tstampNaN = 1;	// pour le debugging
				} else {
					oData.tstamp = tstamp / 1000;
				}
			}
			if (!oData.tstamp) {
				// debug : envoyer toute la page pour comprendre
				oData.fullHTML = document.body.innerHTML;
			}

			// bonus (concentration)
			node = document.evaluate("//b/text()[position()=1 and starts-with(., 'bonus')]",
								document, null, 2, null).stringValue;
			if (node) {
				var bonus = parseInt(node.match(/\d+/));
				if (!isNaN(bonus)) oData.bonus = bonus;
			} else {
				// malus (concentration)
				node = document.evaluate("//b/text()[position()=1 and starts-with(., 'malus')]",
									document, null, 2, null).stringValue;
				if (node && !node.match(/Poison/)) {
					var malus = parseInt(node.match(/\d+/));
					if (!isNaN(malus)) oData.bonus = -malus;
				}
			}

			// compétence/seuil (il peut y en avoir plusieurs si plusieurs niveaux sont essayés car le niveau max ne passe pas)
			var seuilPrimaire;	// stockage pour le cas de course
			var nodes = document.evaluate("//b/text()[position()=1 and contains(., 'jet de')]",
								document, null, 7, null);
			for (var i=0 ; i<nodes.snapshotLength ; i++) {
				var nbrs = nodes.snapshotItem(i).nodeValue.match(/\d+/g);
				if (nbrs.length < 2) continue;	// c'est le cas sur une concentration
				var thisJet = parseInt(nbrs[0])
				var last_seuil = parseInt(nbrs[1]);	// Roule En attendant de revoir le seuil des améliorations
				jets.push({jet: thisJet, seuil: last_seuil});
				if (seuilPrimaire === undefined) seuilPrimaire = last_seuil;
			}

			// amélioration
			// à revoir dès que j'ai une amélio... (said by Tilk in another galaxy, a long time ago)
			// Roule : je confirme : à revoir, en particulier dans le cas de plusieurs améliorations pour plusieurs niveaux
			var eJetAmelio = document.getElementById('jetAmelioration')
			node = document.evaluate("//b[descendant::text()[1]=\"Jet d'amélioration\"]/following::b[1]/descendant::text()[1]",
								document, null, 2, null).stringValue;
			if (node) {
				jets.push({jet: parseInt(node), seuil: last_seuil, type: 'AMEL'});
			}

			// 2e jet : Mélange Magique, LdP
			var eDivJet2 = document.getElementById('msgEffet');
			if (eDivJet2) {
				var txtJet2 = eDivJet2.textContent;
				// Vous tentez de mélanger deux potions avec un risque d'explosion :  jet de 40 sur 17 %
				var resMatchJet2 = txtJet2.match(/risque.*explosion.*jet de *(\d+) * sur *(\d+) *%/);
				if (resMatchJet2 && resMatchJet2.length == 3) {
					jets.push({jet: parseInt(resMatchJet2[1]), seuil: parseInt(resMatchJet2[2]), type: 'MELANGE'});
				}
				// >Un jet de lancer de (98 / 101 %)
				var resMatchJet2 = txtJet2.match(/Un jet de lancer de[\( ]*(\d+)[ /]*(\d+)[ \)]*%/);
				if (resMatchJet2 && resMatchJet2.length == 3) {
					jets.push({jet: parseInt(resMatchJet2[1]), seuil: parseInt(resMatchJet2[2]), type: 'LDP'});
				}
			}

			// SR 27/12/2019 réécriture Roule
			var tabTable = document.getElementsByTagName('table');
			var tabSRseuil = [], tabSRjet = [];
			var lTable = tabTable.length;
			for (var iTable = 0; iTable < lTable; iTable++) {	// on cherche les tables avec le texte correspondant aux jets SR dans les premières cellules des 2 premières lignes
				var eTable = tabTable[iTable];
				var tr0 = eTable.rows[0];
				if (!tr0.cells[0]) continue;
				if (tr0.cells[0].textContent.indexOf('Seuil de Résistance de la Cible') < 0) continue;
				if (!tr0.cells[1]) continue;
				var tr1 = eTable.rows[1];
				if (!tr1) continue;
				if (this.debug) {
					window.console.log('POIS SR tr0 ' + tr0.innerHTML);
					window.console.log('POIS SR tr1 ' + tr1.innerHTML);
				}
				if (!tr1.cells[0]) continue;
				if (!tr1.cells[1]) continue;
				if (tr1.cells[0].textContent.indexOf('Jet de Résistance ') < 0) continue;
				var srSeuil = parseInt(tr0.cells[1].textContent, 10);
				if (isNaN(srSeuil)) continue;
				var srJet = parseInt(tr1.cells[1].textContent, 10);
				if (isNaN(srJet)) continue;
				jets.push({jet: srJet, seuil: srSeuil, type: 'SR'});
			}

			// Course 01/06/2020
			var jetCourse;
			var tabForm = document.getElementsByTagName('form');
			var lForm = tabForm.length;
			for (var iForm = 0; iForm < lForm; iForm++) {
				var formText = tabForm[iForm].textContent;
				if (formText.match(/le rythme de course/i)) {
					jetCourse = 100;
				} else if (formText.match(/un peu à la traine/i)) {
					jetCourse = 0;
				}
			}
			if (jetCourse !== undefined) { // && jetPrimaire !== undefined) {
				// 01/06/2020 en attente de décision sur le seuil
				// 12/07/2020 on bloque car la règle de calcul (du seuil) n'est pas connue
				//jets.push({jet: jetCourse, seuil: last_seuil, type: 'course'});
			}

			if (jets.length == 0) {
				if (this.debug) window.console.log("[POIS] dice : rien à envoyer");
				return false;
			}
			oData.jets = jets;

			if (!this.idTroll) {	// ce test est ici pour ne pas polluer l'écran s'il n'y a de toute façon rien à envoyer
				var msg = "Le Poissotron n'a pas trouvé le numéro de Trõll."
				if (this.erreur) msg += ' '+ this.erreur;
				window.console.log('[POIS] ' + msg);
				this.avertissement(msg, 5000, 'red');
				return;
			}

			// analyse de l'URL (Roule 14/12/2019 je ne sais pas à quoi ça servait, je stocke dans la BdD, on verra bien)
			// Roule 15/12/2019 changement de paradigme, on envoie l'url non bricolée et le referrer. Ça permet de modifier l'analyse ultérieurement coté serveur avec retroanalyse

			oData.url = window.location.href;
			if (document.referrer) oData.referrer = document.referrer;
			oData.id = this.idTroll;
			oData.op = 'dice';
			if (this.modeTest) oData.modeTest = 1;	// pour faciliter le nettoyage en BdD ultérieurement

			//addScript();	// Roule 13/12/2019 Ça faisait quoi, ça ?
			this.doServerRequest(this.callbackDice2, oData);
			return true;
		},

		callbackDice2: function(result, oRequest) {	// relai pour le retour d'envoi du jet
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.callbackDice(result, oRequest);
		},

		callbackDice: function(result, oRequest) {	// retour de l'envoi du jet, affiche simplement un avertissement
			if (this.debug) window.console.log('[POIS] ' + this.formatDateMS() + ' callbackDice reçoit ' + JSON.stringify(result));
			if (result.ok === 1) {
				this.memoKey(result);
				if (true) {	// pour les Beta testeurs, toujours afficher ce qui a été envoyé        this.dev) {
					var msg = 'Jet envoyé au Poissotron';
					if (oRequest.bonus) msg += '<br/>Concentration ' + oRequest.bonus;
					if (oRequest.jets) oRequest.jets.forEach(function (jet) {
						var sType;
						switch (jet.type) {
							case 'AMEL': sType = 'Amélioration'; break;
							case 'MELANGE': sType = 'Mélange magique'; break;
							case undefined: sType = 'Jet'; break;
							default: sType = jet.type; break;
						}
						switch (jet.type) {
							case 'course':
								msg += '<br/>' + sType + (jet.jet > 50 ? ' en rythme' : ' à la traine');
								break;
							default:
								msg += '<br/>' + sType + ' ' + jet.jet + '/' + jet.seuil;
								break;
						}
					});
					if (this.debug && this.dev && oRequest.url) msg += '<br/>url ' + oRequest.url;
					if (this.dev && oRequest.fullHTML) msg += '<br/><span style="color:red;font-size:x-large">Il manque le timestamp</span>';
					this.avertissement(msg, 9999000, 'black', 'yellow');
				} else {
					this.avertissement('Jet envoyé au Poissotron', 2000, 'black');	// affichage pendant 2 secondes
				}
				return;
			}
			var msg = 'Erreur à l\'envoi du jet au Poissotron.'
			if (result.erreur) msg += ' ' + result.erreur;
			window.console.log('[POIS] ' + msg);
			this.avertissement(msg, 10000, 'red');
		},

		avertissement: function(txt, duree, color, bkColor) {	// affichage d'un avertissement en haut de page
			//window.console.log('[POIS] affichage avertissement ' + txt + (duree ? ' pour (' + duree + ' ms)' : ''));
			if(!duree) duree = 15000;	// 15 secondes
			var div = document.createElement('div');
			// On numérote les avertissements pour destruction sélective
			var num = document.getElementsByName('avertissement').length;
			div.num = num;	// Numéro enregistré dans le DOM pour récupération sur getElementsByName()
			div.setAttribute('name','POIS_avertissement');
			div.className = 'mh_textbox';
			div.style.position = 'fixed';
			div.style.top = (10+15*num)+'px';
			div.style.left = (10+5*num)+'px';
			div.style.border = '5px solid ' + color;
			div.style.padding = '5px';
			div.style.paddingRight = '20px';
			div.style.zIndex = 2+num;
			div.style.cursor = 'pointer';
			div.style.fontSize = 'large';
			if (bkColor) div.style.backgroundColor = bkColor;
			div.innerHTML = txt;
			div.onclick=function(){ oPOISSOTRON.tueAvertissement(num) };

			// un croix en haut à droite pour signifier à l'utilisateur qu'il peut cliquer pour fermer ce popup
			var divcroix = document.createElement('div');
			divcroix.style.position = 'absolute';
			divcroix.style.top = 0;
			divcroix.style.right = 0;
			divcroix.style.color = 'black';
			divcroix.style.fontSize = 'inherit';
			divcroix.style.cursor = 'pointer'
			divcroix.style.zIndex = 2+num;
			divcroix.innerHTML = "X";
			div.appendChild(divcroix);

			document.body.appendChild(div);
			// Destruction automatique de l'avertissement après "un certain temps"
			window.setTimeout(function(){ oPOISSOTRON.tueAvertissement(num) },duree);
		},

		tueAvertissement: function(num) {	// suppression de l'avertissement (au bout d'un certain temps)
			var divs = document.getElementsByName('POIS_avertissement');
			if(divs.length==0) { return; }
			for(var i=0 ; i<divs.length ; i++) {
				if(divs[i].num==num) {
					divs[i].parentNode.removeChild(divs[i]);
					return;
				}
			}
		},

		doServerRequest: function(callback, oRequest, bSendSession){	// gère tous les appels AJAX
			var k = window.localStorage.getItem('POIS_KEY_' + this.idTroll);
			if (k) {
				oRequest.key = k;
			} 
			if ((!k) || bSendSession) {
				var cookieSession = this.getCookie('PHPSESSID');	// récupérer le cookie de session MH
				if (cookieSession) oRequest.session = cookieSession;
			}
			oRequest.hostMH = window.location.hostname;
			var request = new XMLHttpRequest();
			var url = this.dev ? this.urldev : this.url;
			if (this.debug) url += '?debug=1';
			//window.console.log('POIS urlPois=' + url + ', dev=' + this.dev);
			request.open('POST', url);
			//request.withCredentials = true;	// Roule 22/01/2020 abandon de l'utilisation de la session PHP coté serveur Poissotron : trop compliqué avec CORS
			request.onreadystatechange = function() {
				//window.console.log('[POIS] xmlhttp onreadystatechange readyState=' + request.readyState + ', status=' + request.status + ' reponseText=' + request.responseText);
				if (request.readyState!=4) { return; }
				if (request.status != 200) {
					callback({erreur:'Erreur de communication avec le serveur du Poissotron : status ' + request.status});
					return;
				}
				var oRet;
				try {
					oRet = JSON.parse(request.responseText);
				} catch (e) {
					callback({erreur:'Erreur dans la réponse du serveur du Poissotron (mauvais JSON)'});
					return;
				}
				if (!oRet) {
					callback({erreur:'Erreur dans la réponse du serveur du Poissotron (réponse vide)'});
					return;
				}
				callback(oRet, oRequest);
			};
			request.send(JSON.stringify(oRequest));
			if (this.debug) window.console.log('[POIS] ' + this.formatDateMS() + ' sent ' + JSON.stringify(oRequest));
		},

		config: function() {	// point d'entrée pour la page de configuration. Teste si tout va bien et affiche le résultat
			var insertPoint = document.getElementById('footer1');	// mettre avant celui-ci
			var insertPoint2 = document.getElementById('MZ_switch_table');	// mais de préférence mettre après celui-ci
			if (!(insertPoint || insertPoint2)) {
				// cas smartphone
				var eForm = document.getElementsByName('ActionForm')[0];
				insertPoint = eForm.nextSibling;
				if (insertPoint) {
					insertPoint2 = insertPoint.nextSibling;
				} else {
					insertPoint = eForm;
				}
			}

			if (insertPoint2) {
				var p = document.createElement('p');
				insertPoint2.parentNode.insertBefore(p, insertPoint2.nextSibling);
				insertPoint2 = p;
			} else {
				insertPoint.parentNode.insertBefore(document.createElement('p'), insertPoint);
			}

			var div = document.createElement('div');
			div.className = 'titre2';
			div.appendChild(document.createTextNode('Poissotron'));
			if (insertPoint2) {
				insertPoint2.parentNode.insertBefore(div, insertPoint2.nextSibling);
				insertPoint2 = div;
			} else {
				insertPoint.parentNode.insertBefore(div,insertPoint);
			}

			var table = document.createElement('table');
			table.className = 'mh_tdborder';
			table.width = '98%';
			var tr = document.createElement('tr');
			tr.className = 'mh_tdpage';
			this.tdConfig = document.createElement('td');
			tr.appendChild(this.tdConfig);
			table.appendChild(tr);

			if (this.idTroll == 91305) {	// liens pour les tests de dev
				tr = document.createElement('tr');
				tr.className = 'mh_tdpage';
				var td = document.createElement('td');
				td.appendChild(document.createTextNode('tests: '));
				['AdD-reussi', 'IdT-echec', 'Retraite-reussi-amelio'
					, 'FA-reussi', 'Melange-reussi', 'DE-malus', 'LdP-reussi'
					, 'smartphone-tp', 'DE-course-rythme', 'DE-course-traine', 'GS-venin'
					, 'cdm3-amelio'].forEach(function(pageTest) {
					var a = document.createElement('a');
					a.href = 'https://mz.mh.raistlin.fr/poissotrondev/tests/' + pageTest + '.html?x=1';
					a.appendChild(document.createTextNode(pageTest));
					td.appendChild(a);
					td.appendChild(document.createTextNode(', '));
				});
				tr.appendChild(td);
				table.appendChild(tr);
			}

			if (insertPoint2) {
				insertPoint2.parentNode.insertBefore(table,insertPoint2.nextSibling);
				insertPoint2 = table;
			} else {
				insertPoint.parentNode.insertBefore(table,insertPoint);
			}

			if (!this.idTroll) {
				var msg = 'Erreur à la récupération de l\'ID Trõll, le poissotron ne peut pas fonctionner.';
				if (this.erreur) msg += ' ' + this.erreur;
				this.tdConfig.appendChild(document.createTextNode(msg));
				return;
			}

			this.checkConfig();
			this.tdConfig.appendChild(document.createTextNode('Vérification en cours...'));
		},

		formatDateMS: function(d, sansMicroSecondes) {	// rend une chaine affichant date et heure et milliseconds (maintenant si le paramètre d est absent)
			if (d === undefined) d = new Date();
			var day = d.getDate();
			var month = d.getMonth()+1;
			var year = d.getFullYear();
			var hours = d.getHours();
			var minutes = d.getMinutes();
			var seconds = d.getSeconds();
			if (day     < 10) {day     = "0"+day;}
			if (month   < 10) {month   = "0"+month;}
			if (hours   < 10) {hours   = "0"+hours;}
			if (minutes < 10) {minutes = "0"+minutes;}
			if (seconds < 10) {seconds = "0"+seconds;}
			if (sansMicroSecondes) {
				return day + '/' + month + '/' + year + ' ' + hours + ':' + minutes + ':' + seconds;
			} else {
				var ms = d.getMilliseconds();
				ms = ('000' + ms).substr(-3, 3);
				return day + '/' + month + '/' + year + ' ' + hours + ':' + minutes + ':' + seconds + '.' + ms;
			}
		},

		callbackChgMode: function() {
			var eImg = document.getElementById('POIS_img_avatar');
			if (!eImg) return;
			var url = eImg.src;
			var iPos = url.indexOf('&');
			if (iPos >= 0) url = url.substring(0, iPos);
			eImg.src = url + '&x=' + new Date().getTime();
			var span = document.getElementById('POIS_confirm_avatar');
			if (span) {
				var eTxt = span.firstChild;
				var txt = eTxt.nodeValue;
				var pos = txt.indexOf('été');
				eTxt.nodeValue = txt.substr(0, pos) + 'encore ' + txt.substr(pos);
			} else {
				span = document.createElement('span');
				span.id = 'POIS_confirm_avatar';
				span.style.color = 'blue';
				span.appendChild(document.createTextNode('Votre choix de Badge a été changé.'));
				var lien = document.getElementById('POIS_line_avatar');
				lien.parentNode.insertBefore(span, lien);
				lien.parentNode.insertBefore(document.createTextNode(' '), lien);
			}
		},

		doChgMode2: function(evt) {
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.doChgMode(evt);
		},

		doChgMode: function(evt) {
			var oSelect = evt.srcElement || evt.originalTarget
			var iNewMode = parseInt(oSelect.options[oSelect.selectedIndex].value, 10);
			var oReq = {op:'avttype', id: this.idTroll, iMode: iNewMode};
			this.doServerRequest(this.callbackChgMode, oReq);
		},

		callbackCheckConfig2: function(result, oRequest) {	// on vient de recevoir le retour d'un checkConfig ou d'un enregistrement
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.callbackCheckConfig(result, oRequest);
		},

		callbackCheckConfig: function(result, oRequest) {	// on vient de recevoir le retour d'un checkConfig ou d'un enregistrement
			if (this.debug) window.console.log('[POIS] ' + this.formatDateMS() + ' callbackCheckConfig reçoit ' + JSON.stringify(result));
			while (c = this.tdConfig.lastChild) this.tdConfig.removeChild(c);	// nettoyer le <td>
			this.tdConfig.removeAttribute('title');
			if (result.ok === 1 && oRequest.op == 'inscri') {
				// on dit à l'utilisateur que tout va bien
				this.tdConfig.appendChild(document.createTextNode('Votre Trõll est maintenant enregistré sur le Poissotron'));
			} else if (result.ok === 1) {
				this.memoKey(result);
				// on dit à l'utilisateur que tout va bien
				this.tdConfig.appendChild(document.createTextNode('Votre compte Poissotron est valide'));

				// 02/01/2020 ajout de l'affichage du détail des calculs
				this.butDetail = document.createElement('input');
				this.butDetail.type = 'button';
				this.butDetail.className = 'mh_form_submit';
				this.butDetail.value = 'Voir le détail des calculs';
				this.butDetail.onclick = this.appelDetailCalcul2;
				this.tdConfig.appendChild(document.createTextNode(' '));
				this.tdConfig.appendChild(this.butDetail);

				// ajout d'un formulaire pour télécharger les jets
				this.formJets = document.createElement('form');
				this.formJets.style.display = 'inline-block';
				this.formJets.enctype = 'application/x-www-form-urlencoded';
				this.formJets.method = 'POST';
				this.formJets.action = (this.dev ? this.urldev : this.url);// + '?form=1';
				this.butJets = document.createElement('input');
				this.butJets.type = 'submit';
				this.butJets.className = 'mh_form_submit';
				this.butJets.value = 'Télécharger tous mes jets';
				this.butJets.title = 'En format CSV';
				this.formJets.appendChild(this.butJets);
				this.addHidden('op', 'getjet', this.formJets);
				this.addHidden('id', this.idTroll, this.formJets);
				var k = window.localStorage.getItem('POIS_KEY_' + this.idTroll);
				if (k) {
					this.addHidden('key', k, this.formJets);
				} else {
					var cookieSession = this.getCookie('PHPSESSID');	// récupérer le cookie de session MH
					if (cookieSession) this.addHidden('session', cookieSession, this.formJets);
				}
				this.tdConfig.appendChild(document.createTextNode(' '));
				this.tdConfig.appendChild(this.formJets);

				// typeAvatar
				if (result.listTypeAvatar !== undefined) {
					var nbMode = result.listTypeAvatar.length;
					var combo = document.createElement('select');
					for (var iMode = 0; iMode < nbMode; iMode++) {
						var opt = document.createElement('option');
						opt.value = iMode;
						opt.text = result.listTypeAvatar[iMode];
						if (result.typeAvatar === iMode) opt.selected = true;
						combo.add(opt);
					}
					combo.addEventListener("change", this.doChgMode2);
					this.divMode = document.createElement('div');
					if (result.typeAvatar === undefined) {
						result.typeAvatar = 0;
						this.divMode.appendChild(document.createTextNode("Vous n'avez pas encore choisi votre type de badge\u00A0:\u00A0"));
					} else {
						this.divMode.appendChild(document.createTextNode("Choix du type de badge\u00A0:\u00A0"));
					}
					this.divMode.appendChild(combo);
					var a = document.createElement('a');
					a.id = 'POIS_line_avatar';
					a.target = 'poissotron';
					a.href = "https://mz.mh.raistlin.fr/poissotron/images1.php";
					a.appendChild(document.createTextNode('Voir les belles images pour pouvoir choisir'));
					this.divMode.appendChild(document.createTextNode(' '));
					this.divMode.appendChild(a);
					this.tdConfig.appendChild(this.divMode);
				}

				// ajout d'un lien vers la page d'accueil du Poissotron et badge
				this.divBadge = document.createElement('div');
				var a = document.createElement('a');
				a.target = 'poissotron';
				a.href = "https://mz.mh.raistlin.fr/poissotron";
				a.appendChild(document.createTextNode('Page du Poissotron'));
				a.appendChild(document.createElement('br'));
				// badge
				var img = document.createElement('img');
				img.src = 'https://mz.mh.raistlin.fr/poissotron/profil.php?troll=' + this.idTroll;
				img.id = 'POIS_img_avatar';
				img.style.verticalAlign = 'top';	// Pour mettre le texte en haut, c'est l'image qui doit être "vAlign top". Logique CSS !
				a.appendChild(document.createTextNode('Vous êtes :'));
				a.appendChild(img);
				this.divBadge.appendChild(a);
				this.tdConfig.appendChild(this.divBadge);

			} else if (result.ok === -1) {	// Trõll pas encore enregistré sur le Poissotron
				this.tdConfig.appendChild(document.createTextNode('Vous n\'êtes pas encore enregistré sur le Poissoton'));
				this.butEnreg = document.createElement('input');
				this.butEnreg.type = 'button';
				this.butEnreg.className = 'mh_form_submit';
				this.butEnreg.value = 'M\'enregistrer sur le Poissotron';
				this.butEnreg.title = 'Et j\'obtiendrai immédiatement le grade de Newbie';
				this.butEnreg.onclick = this.appelEnregistrement2;
				this.tdConfig.appendChild(document.createTextNode(' '));
				this.tdConfig.appendChild(this.butEnreg);
			} else {
				var erreur = result.erreur;
				if (!erreur) erreur = 'Erreur inconnue, JSON=' + JSON.stringify(result);
				this.tdConfig.appendChild(document.createTextNode(erreur));
			}
		},

		addHidden: function(name, value, eParent) {
			var e = document.createElement('input');
			e.type = 'hidden';
			e.value = value;
			e.name = name;
			eParent.appendChild(e);
		},

		memoKey: function(result) {
			if (!result.key) return;
			window.localStorage.setItem('POIS_KEY_' + this.idTroll, result.key);
		},

		appelEnregistrement2: function () {	// l'utilisateur a cliqué sur le bouton de demande d'enregistrement sur le Poissotron
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.appelEnregistrement();
		},

		appelEnregistrement: function () {	// l'utilisateur a cliqué sur le bouton de demande d'enregistrement sur le Poissotron
			var oReq = {op:'inscri', id: this.idTroll};
			this.doServerRequest(this.callbackCheckConfig2, oReq, true);
			if (!this.butEnreg) return;
			this.butEnreg.value = 'Enregistrement en cours...';
			this.butEnreg.onclick = undefined;
		},

		appelDetailCalcul2: function() {	// l'utilisateur a cliqué sur le bouton de demande des détails de calcul
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.appelDetailCalcul();
		},

		appelDetailCalcul: function() {	// l'utilisateur a cliqué sur le bouton de demande des détails de calcul
			var oReq = {op:'detcalc', id: this.idTroll};
			this.doServerRequest(this.callbackDetailCalcul2, oReq);
			if (!this.butDetail) return;
			this.butDetail.value = 'Calcul en cours...';
			this.butDetail.onclick = undefined;
		},

		callbackDetailCalcul2: function(result, oRequest) {	// on a reçu le détail des calculs
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.callbackDetailCalcul(result, oRequest);
		},

		callbackDetailCalcul: function(result, oRequest) {	// on a reçu le détail des calculs
			if (result.ok !== 1) {
				var erreur = result.erreur;
				if (!erreur) erreur = 'Erreur inconnue, JSON=' + JSON.stringify(result);
				this.butDetail.value = 'Voir le détail des calculs';
				this.butDetail.onclick = this.appelDetailCalcul2;
				this.tdConfig.appendChild(document.createElement('br'));
				this.tdConfig.appendChild(document.createTextNode(erreur));
				return;
			}
			this.divBadge.parentNode.removeChild(this.divBadge);
			this.memoKey(result);
			if (this.butDetail) {
				this.butDetail.parentNode.removeChild(this.butDetail);
				this.butDetail = undefined;
			}
			// affichage des tables
			for (var iTable = 0; iTable < result.tables.length; iTable++) this.affTableJSON(result.tables[iTable], this.tdConfig);
		},

		affTableJSON: function(tabl, parentNode) {	// fonction générique d'affichage d'une table
			var eDiv = document.createElement('div');
			if (tabl.texte) eDiv.appendChild(document.createTextNode(tabl.texte));
			var eTable = document.createElement('table');
			eTable.className = 'mh_tdborder';
			tabl.rows.forEach(function (row) {
				var tr = eTable.insertRow(-1);
				tr.className = 'mh_tdpage';
				if (row.style) Object.keys(row.style).forEach(function(styleKey) {
					tr.style[styleKey] = row.style[styleKey];
				});
				row.cells.forEach(function (cell) {
					var td = tr.insertCell(-1)
					if (cell.style) Object.keys(cell.style).forEach(function(styleKey) {
						td.style[styleKey] = cell.style[styleKey];
					});
					td.appendChild(document.createTextNode(cell.t));
				});
				//window.console.log('insert row, nCell = ' + row.cells.length + ' html ' + tr.cells.length);
			});
			eDiv.appendChild(eTable);
			parentNode.appendChild(eDiv);
		},

		checkConfig2 : function() {	// relai pour la vérification de configuration en cas appel sur action utilisateur
			// on est obligé de repartir de la variable globale oPOISSOTRON car on n'est plus dans le contexte de cet objet
			oPOISSOTRON.checkConfig();
		},

		checkConfig : function() {	// vérification de la configuration <numéro de Trõll, clef> ou activation de la configuration
			var oReq = {op:'check', id: this.idTroll};
			if (this.inputConfig) oReq.code = this.inputConfig.value;
			this.doServerRequest(this.callbackCheckConfig2, oReq, true);
			if (!this.butConfig) return;
			this.butConfig.value = 'Validation en cours...';
			this.butConfig.onclick = undefined;
		},

		getCookie : function(cname) {
			var name = cname + "=";
			var decodedCookie = decodeURIComponent(document.cookie);
			var ca = decodedCookie.split(';');
			for(var i = 0; i <ca.length; i++) {
				var c = ca[i];
				while (c.charAt(0) == ' ') {
						c = c.substring(1);
					}
					if (c.indexOf(name) == 0) {
					return c.substring(name.length, c.length);
				}
			}
		},

		init: function() {	// quelques initialisations pour tous les modes : mode dev, récupération de l'ID Trõll
			// tester si on est en dev
			var tabScripts = document.getElementsByTagName('script');
			var l = tabScripts.length;
			for (var i = 0; i < l; i++) {	// boucler sur les scripts jusqu'à trouver celui qui parle du poissotron
				var eScript = tabScripts[i];
				if (eScript.src.indexOf('poissotron') >= 0) {
					if (eScript.src.indexOf('dev') >= 0) this.dev = true;	// on est en dev s'il y a "dev" dans l'URL
					//window.console.log('POIS js src=' + eScript.src + ', dev=' + this.dev);
					break;
				}
			}
			// récupérer l'ID du Trõll
			if (this.modeTest) return;	// pour les tests, on a forcé le numéro de Trõll avant
			try {
				// priorité : tentative de récupération dans la page elle même (en mode spmartphone)
				var eID = document.getElementById('id');
				if (eID) this.idTroll = parseInt(eID.getAttribute('data-id'));
				if ((!this.idTroll) || isNaN(this.idTroll)) {
					var frameMenu = top.Sommaire.document;
					var eID = frameMenu.getElementById('id');
					if (eID) this.idTroll = parseInt(eID.getAttribute('data-id'));
					if ((!this.idTroll) || isNaN(this.idTroll)) {
						// ancienne méthode, analyse du javascript onclick="EnterPJView(91305,750,550)"
						var tabA = frameMenu.getElementsByTagName('a');
						if (tabA.length > 0 && tabA[0].onclick !== undefined) {
							var s = tabA[0].onclick.toString();
							var m = s.match(/\((\d+) *,/);
							this.idTroll = parseInt(m[1]);
							//window.console.log('[POIS] s=' + JSON.stringify(s) + ' ' + typeof(s) + ' ' + s.toString() + ', m=' + JSON.stringify(m) + ', numTrõll=' + this.idTroll);
						}
					}
				}
			} catch (e) {
				this.erreur = 'Exception à la récupération de l\'ID Trõll ' + e;
			}
		},

		dispatch: function() {	// point d'entrée
			// appeler la fonction qui-va-bien en fonction de la page
			var url = window.location.pathname;
			if (url.indexOf('/mountyhall/MH_Play/Play_a_ActionResult') == 0) {
				this.init();
				this.sendDices();
			} else if (url.indexOf('/poissotrondev/tests/') == 0) {	// spécial pour les tests de dev
				if (POIS_idTroll) {	// variable globale à définir un fois dans le .html de test (ainsi que POIS_key)
					window.localStorage.setItem('POIS_IDTROLL_TESTS', POIS_idTroll);
					window.localStorage.setItem('POIS_KEY_' + POIS_idTroll, POIS_key);
				}
				this.modeTest = 1;
				this.idTroll = window.localStorage.getItem('POIS_IDTROLL_TESTS');
				this.init();
				this.sendDices();
			} else if (url.indexOf('/mountyhall/MH_Play/Options/Play_o_Interface') == 0) {
				this.init();
				this.config();
			}
		},
	};
}

oPOISSOTRON.dispatch();
